import {
  startAuthentication,
  startRegistration
} from "@simplewebauthn/browser";
export * from "@simplewebauthn/browser";
let nanoid = (t = 21) => crypto.getRandomValues(new Uint8Array(t)).reduce(
  (t2, e) => t2 += (e &= 63) < 36 ? e.toString(36) : e < 62 ? (e - 26).toString(36).toUpperCase() : e > 62 ? "-" : "_",
  ""
);
function handleFormSubmit(options, type = "registration", generateUserId) {
  return async function handleSubmit(event) {
    var _a, _b, _c;
    if (!(event.nativeEvent instanceof SubmitEvent) || !(event.nativeEvent.submitter instanceof HTMLButtonElement)) {
      event.preventDefault();
      return false;
    }
    if (event.nativeEvent.submitter.formMethod === "get") {
      return true;
    }
    const target = event.currentTarget;
    type = ((_b = (_a = event == null ? void 0 : event.nativeEvent) == null ? void 0 : _a.submitter) == null ? void 0 : _b.value) || ((_c = target.type) == null ? void 0 : _c.value) || type;
    event.preventDefault();
    const responseValue = type === "authentication" ? JSON.stringify(
      await startAuthentication({
        challenge: options.challenge,
        allowCredentials: options.authenticators,
        rpId: options.rp.id,
        userVerification: "preferred",
        timeout: 90 * 1e3
      })
    ) : JSON.stringify(
      await startRegistration({
        challenge: options.challenge,
        excludeCredentials: options.authenticators,
        rp: options.rp,
        user: {
          id: (generateUserId == null ? void 0 : generateUserId()) || nanoid(),
          name: target.email.value,
          displayName: target.email.value
        },
        pubKeyCredParams: [
          {
            alg: -7,
            type: "public-key"
          },
          {
            alg: -257,
            type: "public-key"
          }
        ],
        timeout: 90 * 1e3,
        attestation: "none",
        authenticatorSelection: {
          residentKey: "discouraged",
          requireResidentKey: false
        },
        extensions: { credProps: true }
      })
    );
    let responseEl = target.querySelector(
      'input[name="response"]'
    );
    if (!responseEl) {
      responseEl = Object.assign(document.createElement("input"), {
        type: "hidden",
        name: "response"
      });
      target.prepend(responseEl);
    }
    responseEl.value = responseValue;
    let typeEl = target.querySelector('input[name="type"]');
    if (!typeEl) {
      typeEl = Object.assign(document.createElement("input"), {
        type: "hidden",
        name: "type"
      });
      target.prepend(typeEl);
    }
    typeEl.value = type;
    target.submit();
  };
}
export {
  handleFormSubmit,
  nanoid
};
